/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "game.h"

bool gameInit(game_t *game) {
  // Init the game
  game->name = GAME_NAME;
  
  engineInit(&game->engine, game);

  // assetShaderLoad(&game->shader,"shaders/textured.vert","shaders/textured.frag");
  // assetTextureLoad(&game->texture, "cards_normal.png");
  // cubeInit(&game->primitive, 1, 1, 1);

  // // Load the world shader.
  // GAME_STATE.shaderWorld = assetShaderLoad(
  //   "shaders/textured.vert", "shaders/textured.frag"
  // );

  // // Font
  // GAME_STATE.fontTexture = assetTextureLoad("font.png");
  // GAME_STATE.fontTileset = tilesetCreate(20, 20,
  //   GAME_STATE.fontTexture->width,
  //   GAME_STATE.fontTexture->height,
  //   1, 1, 1, 1
  // );
  // GAME_STATE.fontBatch = spriteBatchCreate(1024);

  // // Prepare the renderer.
  // pokerInit(&GAME_STATE.poker);
  // holdemRenderFrameInit();
  // holdemRenderWorldInit();
  // holdemRenderPlayerInit();
  // holdemRenderCardInit();
  // holdemRenderChipInit();

  // Init the input manger.
  return true;
}

bool gameUpdate(game_t *game, float platformDelta) {
  engineUpdateStart(&game->engine, game, platformDelta);
  
  cameraPerspective(&game->camera, 75,
    ((float)game->engine.render.width)/((float)game->engine.render.height),
    0.01, 1000
  );
  cameraLookAt(&game->camera, 3, 3, 3, 0, 0, 0);
  shaderUse(&game->shader);
  shaderUseTexture(&game->shader, &game->texture);
  shaderUseCamera(&game->shader, &game->camera);
  shaderUsePosition(&game->shader, 0, 0, 0, 0, game->engine.time.current, 0);
  primitiveDraw(&game->primitive, 0, -1);


  // shaderUse(GAME_STATE.shaderWorld);// TODO: remove
  
  // // Update the frame buffers and action queue
  // holdemRenderFrameUpdate();
  // pokerActionUpdate();

  // // Render things on each frame, then render those frames.
  // holdemRenderFrameUseLeft();
  // holdemRenderWorld();
  // holdemRenderFrameUseRight();
  // holdemRenderWorld();
  // holdemRenderFrameBack();

  return engineUpdateEnd(&game->engine, game);
}

void gameDispose(game_t *game) {
  engineDispose(&game->engine, game);
  // pokerActionDispose();
  // shaderDispose(GAME_STATE.shaderWorld);
}